﻿using System;
using System.Windows.Forms;
using Microsoft.VisualBasic.Devices;
//
namespace Sistema_operativo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        //
        private void Form1_Load(object sender, EventArgs e)
        {
            CancelButton = this.BotonSalir;
            //
			// USANDO COMPUTER Y ENVIRONMENT
            // La clase Environment del espacio de nombres System proporciona información acerca del entorno y la plataforma actuales.
            // La propiedad Environment.OSVersion obtiene un objeto que contiene el identificador de la plataforma actual y el número de versión
            LabelInfo1.Text = "System.Environment.OSVersion:\n\n" + System.Environment.OSVersion.ToString();
            //
            // La clase Computer del espacio de nombres Microsoft.VisualBasic.Devices proporciona propiedades para manipular componentes del equipo
            // Es una forma de utilizar en C# el objeto My que no existe como tal en este lenguaje y sí en Visual Basic .NET
            // En VB el espacio de nombres My proporciona  a la aplicación acceso a 7 objetos:
            // - My.Computer: nombre del ordenador, memoria, sistema operativo, red, etc.
            // - My.Application: ruta a la aplicación, ensamblados, variables de entorno, etc.
            // - My.User: información sobre el usuario actual de Windows
            // - My.Forms: proporciona referenca a todos los formularios del proyecto
            // - My.WebServices: clases y servicios web utilizados
            // - My.Settings: lee o guarda configuraciones de la aplicación
            // - My.Resources: lee recursos utilizados por la aplicación.
            // En C# hay que añadir una referencia a Microsoft.VisualBasic y se importa Microsoft.VisualBasic.Devices
            // para generar objetos Computer y obtener información como se hace en VB desde My.Computer
            Computer pc = new Computer();
            LabelInfo2.Text = "Computer.Info.OSFullName:\n\n" + pc.Info.OSFullName.ToString();
            //
            // USANDO REGISTRO DE WINDOWS
			//
            // La información sobre la versión, edición, números de versión y compilación del sistema operativo está en la clave
            // [HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\Microsoft\Windows NT\CurrentVersion]
            // En las claves ProductName / EditionID / CurrentBuild / CurrentVersion / etc.
            string Clave1 = @"SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion";
            // La información sobre la arquitectura de 32 o 64 bits se obtiene mejor desde la clave
            // [HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager\Environment]
            // En la clave PROCESSOR_ARCHITECTURE que puede ser AMD64 o x86
            string Clave2 = @"SYSTEM\CurrentControlSet\Control\Session Manager\Environment";
			//
            Microsoft.Win32.RegistryKey principal = Microsoft.Win32.Registry.LocalMachine; //rama LocalMachine
            Microsoft.Win32.RegistryKey subclave1 = principal.OpenSubKey(Clave1); //clave SOFTWARE ... CurrentVersion
            Microsoft.Win32.RegistryKey subclave2 = principal.OpenSubKey(Clave2); //clave SYSTEM ...  Environment
            // valores de varias cadenas de CurrentVersion
            string nombre = subclave1.GetValue("ProductName").ToString();
            string compilacion = subclave1.GetValue("CurrentBuild").ToString();
            string release = subclave1.GetValue("ReleaseId").ToString();
            // valor de la cadena PROCESSOR_ARCHITECTURE de Environment
            string arquitectura = subclave2.GetValue("PROCESSOR_ARCHITECTURE").ToString();
            if (arquitectura.Equals("AMD64"))
                arquitectura = "64 bits";
            else
                arquitectura = "32 bits";
            // Mostrar nombre, compilación, versión y arquitectura del sistema operativo
            LabelInfo3.Text = "ProductName:\n" + nombre + "\n\nCurrentBuild:\n" + compilacion + "\n\nReleaseId:\n" + release + "\n\nProcessor_Architecture:\n" + arquitectura;
        }
        //
        private void BotonSalir_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
